
import cookielib
import gzip


class CompressedLWPCookieJar(cookielib.LWPCookieJar):

    def save(self, filename=None, ignore_discard=False, ignore_expires=False):
        try:
            cookielib.LWPCookieJar.save(self, filename=filename, ignore_discard=ignore_discard, ignore_expires=ignore_expires)
            content = ""
            with open(filename, "rb") as f:
                content = f.read()
                f.close()

            f = gzip.open(filename, 'wb')
            f.write(content)
            f.close()

        except Exception as e:
            pass

    def load(self, filename=None, ignore_discard=False, ignore_expires=False):
        if hasattr(self, "_loaded") and self._loaded:
            return

        try:
            decompressed_file = None
            with open(filename, "rb") as f:
                decompressed_file = gzip.GzipFile(fileobj=f)
                f.close()

            if decompressed_file:
                with open(filename, "wb") as f:
                    f.write(decompressed_file.read())

            cookielib.LWPCookieJar.load(self, filename=filename, ignore_discard=ignore_discard, ignore_expires=ignore_expires)
            self._loaded = True
        except Exception as e:
            pass
